Index: uspace/srv/devman/client_conn.c
===================================================================
--- uspace/srv/devman/client_conn.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/client_conn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,5 +66,5 @@
 	devman_handle_t handle;
 	
-	errno_t rc = async_data_write_accept((void **) &pathname, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **) &pathname, true, 0, 0, 0, 0);
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
@@ -363,5 +363,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -400,5 +400,5 @@
 	fibril_rwlock_read_unlock(&device_tree.rwlock);
 	
-	errno_t retval = async_data_read_finalize(callid, hdl_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, hdl_buf, size);
 	free(hdl_buf);
 	
@@ -440,5 +440,5 @@
 {
 	fun_node_t *fun;
-	errno_t rc;
+	int rc;
 
 	fun = find_fun_node(&device_tree, IPC_GET_ARG1(*icall));
@@ -451,5 +451,5 @@
 	fun_del_ref(fun);
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -465,5 +465,5 @@
 {
 	fun_node_t *fun;
-	errno_t rc;
+	int rc;
 
 	fun = find_fun_node(&device_tree, IPC_GET_ARG1(*icall));
@@ -476,5 +476,5 @@
 	fun_del_ref(fun);
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -511,5 +511,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -532,5 +532,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, hdl_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, hdl_buf, size);
 	free(hdl_buf);
 	
@@ -543,5 +543,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -572,5 +572,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, hdl_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, hdl_buf, size);
 	free(hdl_buf);
 	
@@ -584,5 +584,5 @@
 	char *drvname;
 	
-	errno_t rc = async_data_write_accept((void **) &drvname, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **) &drvname, true, 0, 0, 0, 0);
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
@@ -711,5 +711,5 @@
 {
 	driver_t *drv;
-	errno_t rc;
+	int rc;
 	
 	drv = driver_find(&drivers_list, IPC_GET_ARG1(*icall));
@@ -730,5 +730,5 @@
 {
 	driver_t *drv;
-	errno_t rc;
+	int rc;
 	
 	drv = driver_find(&drivers_list, IPC_GET_ARG1(*icall));
Index: uspace/srv/devman/dev.c
===================================================================
--- uspace/srv/devman/dev.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/dev.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -127,5 +127,5 @@
 
 /** Get list of device functions. */
-errno_t dev_get_functions(dev_tree_t *tree, dev_node_t *dev,
+int dev_get_functions(dev_tree_t *tree, dev_node_t *dev,
     devman_handle_t *hdl_buf, size_t buf_size, size_t *act_size)
 {
Index: uspace/srv/devman/dev.h
===================================================================
--- uspace/srv/devman/dev.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/dev.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,5 @@
     devman_handle_t handle);
 extern dev_node_t *find_dev_node(dev_tree_t *tree, devman_handle_t handle);
-extern errno_t dev_get_functions(dev_tree_t *tree, dev_node_t *, devman_handle_t *,
+extern int dev_get_functions(dev_tree_t *tree, dev_node_t *, devman_handle_t *,
     size_t, size_t *);
 
Index: uspace/srv/devman/devman.h
===================================================================
--- uspace/srv/devman/devman.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/devman.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -80,5 +80,5 @@
 	char *name;
 	/** Path to the driver's binary. */
-	char *binary_path;
+	const char *binary_path;
 	/** List of device ids for device-to-driver matching. */
 	match_id_list_t match_ids;
Index: uspace/srv/devman/devtree.c
===================================================================
--- uspace/srv/devman/devtree.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/devtree.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -198,5 +198,5 @@
 	dev_node_t *rdev = tree->root_node->child;
 	dev_add_ref(rdev);
-	bool rc = assign_driver(rdev, drivers_list, tree);
+	int rc = assign_driver(rdev, drivers_list, tree);
 	dev_del_ref(rdev);
 	
Index: uspace/srv/devman/driver.c
===================================================================
--- uspace/srv/devman/driver.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/driver.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -140,5 +140,5 @@
 	
 	/* Check whether the driver's binary exists. */
-	vfs_stat_t s;
+	struct stat s;
 	if (vfs_stat_path(drv->binary_path, &s) != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Driver not found at path `%s'.",
@@ -283,5 +283,5 @@
 bool start_driver(driver_t *drv)
 {
-	errno_t rc;
+	int rc;
 
 	assert(fibril_mutex_is_locked(&drv->driver_mutex));
@@ -306,8 +306,8 @@
  *			otherwise.
  */
-errno_t stop_driver(driver_t *drv)
+int stop_driver(driver_t *drv)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "stop_driver(drv=\"%s\")", drv->name);
@@ -591,5 +591,5 @@
 	
 	/* Send the device name to the driver. */
-	errno_t rc = async_data_write_start(exch, dev->pfun->name,
+	sysarg_t rc = async_data_write_start(exch, dev->pfun->name,
 	    str_size(dev->pfun->name) + 1);
 	
@@ -618,8 +618,8 @@
 }
 
-errno_t driver_dev_remove(dev_tree_t *tree, dev_node_t *dev)
+int driver_dev_remove(dev_tree_t *tree, dev_node_t *dev)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	driver_t *drv;
 	devman_handle_t handle;
@@ -641,8 +641,8 @@
 }
 
-errno_t driver_dev_gone(dev_tree_t *tree, dev_node_t *dev)
+int driver_dev_gone(dev_tree_t *tree, dev_node_t *dev)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	driver_t *drv;
 	devman_handle_t handle;
@@ -664,8 +664,8 @@
 }
 
-errno_t driver_fun_online(dev_tree_t *tree, fun_node_t *fun)
+int driver_fun_online(dev_tree_t *tree, fun_node_t *fun)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	driver_t *drv;
 	devman_handle_t handle;
@@ -692,8 +692,8 @@
 }
 
-errno_t driver_fun_offline(dev_tree_t *tree, fun_node_t *fun)
+int driver_fun_offline(dev_tree_t *tree, fun_node_t *fun)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	driver_t *drv;
 	devman_handle_t handle;
@@ -721,5 +721,5 @@
 
 /** Get list of registered drivers. */
-errno_t driver_get_list(driver_list_t *driver_list, devman_handle_t *hdl_buf,
+int driver_get_list(driver_list_t *driver_list, devman_handle_t *hdl_buf,
     size_t buf_size, size_t *act_size)
 {
@@ -753,5 +753,5 @@
 
 /** Get list of device functions. */
-errno_t driver_get_devices(driver_t *driver, devman_handle_t *hdl_buf,
+int driver_get_devices(driver_t *driver, devman_handle_t *hdl_buf,
     size_t buf_size, size_t *act_size)
 {
Index: uspace/srv/devman/driver.h
===================================================================
--- uspace/srv/devman/driver.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/driver.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,10 +50,10 @@
 extern void detach_driver(dev_tree_t *, dev_node_t *);
 extern bool start_driver(driver_t *);
-extern errno_t stop_driver(driver_t *);
+extern int stop_driver(driver_t *);
 extern void add_device(driver_t *, dev_node_t *, dev_tree_t *);
-extern errno_t driver_dev_remove(dev_tree_t *, dev_node_t *);
-extern errno_t driver_dev_gone(dev_tree_t *, dev_node_t *);
-extern errno_t driver_fun_online(dev_tree_t *, fun_node_t *);
-extern errno_t driver_fun_offline(dev_tree_t *, fun_node_t *);
+extern int driver_dev_remove(dev_tree_t *, dev_node_t *);
+extern int driver_dev_gone(dev_tree_t *, dev_node_t *);
+extern int driver_fun_online(dev_tree_t *, fun_node_t *);
+extern int driver_fun_offline(dev_tree_t *, fun_node_t *);
 
 extern driver_t *driver_find(driver_list_t *, devman_handle_t);
@@ -64,6 +64,6 @@
 extern void clean_driver(driver_t *);
 extern void delete_driver(driver_t *);
-extern errno_t driver_get_list(driver_list_t *, devman_handle_t *, size_t, size_t *);
-extern errno_t driver_get_devices(driver_t *, devman_handle_t *, size_t, size_t *);
+extern int driver_get_list(driver_list_t *, devman_handle_t *, size_t, size_t *);
+extern int driver_get_devices(driver_t *, devman_handle_t *, size_t, size_t *);
 
 #endif
Index: uspace/srv/devman/drv_conn.c
===================================================================
--- uspace/srv/devman/drv_conn.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/drv_conn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,5 +61,5 @@
 #include "main.h"
 
-static errno_t init_running_drv(void *drv);
+static int init_running_drv(void *drv);
 
 /** Register running driver. */
@@ -72,5 +72,5 @@
 	
 	/* Get driver name. */
-	errno_t rc = async_data_write_accept((void **) &drv_name, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **) &drv_name, true, 0, 0, 0, 0);
 	if (rc != EOK) {
 		async_answer_0(callid, rc);
@@ -161,12 +161,12 @@
  *
  * @param match_ids	The list of the device's match ids.
- * @return		Zero on success, error code otherwise.
- */
-static errno_t devman_receive_match_id(match_id_list_t *match_ids)
+ * @return		Zero on success, negative error code otherwise.
+ */
+static int devman_receive_match_id(match_id_list_t *match_ids)
 {
 	match_id_t *match_id = create_match_id();
 	ipc_callid_t callid;
 	ipc_call_t call;
-	errno_t rc = 0;
+	int rc = 0;
 	
 	callid = async_get_call(&call);
@@ -211,10 +211,10 @@
  * @param match_count	The number of device's match ids to be received.
  * @param match_ids	The list of the device's match ids.
- * @return		Zero on success, error code otherwise.
- */
-static errno_t devman_receive_match_ids(sysarg_t match_count,
+ * @return		Zero on success, negative error code otherwise.
+ */
+static int devman_receive_match_ids(sysarg_t match_count,
     match_id_list_t *match_ids)
 {
-	errno_t ret = EOK;
+	int ret = EOK;
 	size_t i;
 	
@@ -255,5 +255,5 @@
 	
 	char *fun_name = NULL;
-	errno_t rc = async_data_write_accept((void **)&fun_name, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **)&fun_name, true, 0, 0, 0, 0);
 	if (rc != EOK) {
 		dev_del_ref(pdev);
@@ -332,5 +332,5 @@
 	devman_handle_t handle = IPC_GET_ARG1(*call);
 	category_id_t cat_id;
-	errno_t rc;
+	int rc;
 	
 	/* Get category name. */
@@ -381,5 +381,5 @@
 {
 	fun_node_t *fun;
-	errno_t rc;
+	int rc;
 	
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "devman_drv_fun_online()");
@@ -407,5 +407,5 @@
 		fun_busy_unlock(fun);
 		fun_del_ref(fun);
-		async_answer_0(iid, rc);
+		async_answer_0(iid, (sysarg_t) rc);
 		return;
 	}
@@ -414,5 +414,5 @@
 	fun_del_ref(fun);
 	
-	async_answer_0(iid, EOK);
+	async_answer_0(iid, (sysarg_t) EOK);
 }
 
@@ -425,5 +425,5 @@
 {
 	fun_node_t *fun;
-	errno_t rc;
+	int rc;
 
 	fun = find_fun_node(&device_tree, IPC_GET_ARG1(*icall));
@@ -448,5 +448,5 @@
 		fun_busy_unlock(fun);
 		fun_del_ref(fun);
-		async_answer_0(iid, rc);
+		async_answer_0(iid, (sysarg_t) rc);
 		return;
 	}
@@ -454,5 +454,5 @@
 	fun_busy_unlock(fun);
 	fun_del_ref(fun);
-	async_answer_0(iid, EOK);
+	async_answer_0(iid, (sysarg_t) EOK);
 }
 
@@ -462,5 +462,5 @@
 	devman_handle_t fun_handle = IPC_GET_ARG1(*call);
 	dev_tree_t *tree = &device_tree;
-	errno_t rc;
+	int rc;
 	
 	fun_node_t *fun = find_fun_node(&device_tree, fun_handle);
@@ -490,5 +490,5 @@
 			dev_node_t *dev = fun->child;
 			device_state_t dev_state;
-			errno_t gone_rc;
+			int gone_rc;
 			
 			dev_add_ref(dev);
@@ -575,5 +575,5 @@
  * driver needed to be served by devman during the driver's initialization).
  */
-static errno_t init_running_drv(void *drv)
+static int init_running_drv(void *drv)
 {
 	driver_t *driver = (driver_t *) drv;
Index: uspace/srv/devman/fun.c
===================================================================
--- uspace/srv/devman/fun.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/fun.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -286,5 +286,5 @@
 }
 
-static errno_t assign_driver_fibril(void *arg)
+static int assign_driver_fibril(void *arg)
 {
 	dev_node_t *dev_node = (dev_node_t *) arg;
@@ -296,5 +296,5 @@
 }
 
-errno_t fun_online(fun_node_t *fun)
+int fun_online(fun_node_t *fun)
 {
 	dev_node_t *dev;
@@ -354,7 +354,7 @@
 }
 
-errno_t fun_offline(fun_node_t *fun)
-{
-	errno_t rc;
+int fun_offline(fun_node_t *fun)
+{
+	int rc;
 	
 	fibril_rwlock_write_lock(&device_tree.rwlock);
Index: uspace/srv/devman/fun.h
===================================================================
--- uspace/srv/devman/fun.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/fun.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,6 +49,6 @@
     const char *);
 extern bool set_fun_path(dev_tree_t *, fun_node_t *, fun_node_t *);
-extern errno_t fun_online(fun_node_t *);
-extern errno_t fun_offline(fun_node_t *);
+extern int fun_online(fun_node_t *);
+extern int fun_offline(fun_node_t *);
 
 #endif
Index: uspace/srv/devman/loc.c
===================================================================
--- uspace/srv/devman/loc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/loc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,7 +67,7 @@
 }
 
-errno_t loc_unregister_tree_function(fun_node_t *fun, dev_tree_t *tree)
+int loc_unregister_tree_function(fun_node_t *fun, dev_tree_t *tree)
 {
-	errno_t rc = loc_service_unregister(fun->service_id);
+	int rc = loc_service_unregister(fun->service_id);
 	tree_rem_loc_function(tree, fun);
 	return rc;
Index: uspace/srv/devman/loc.h
===================================================================
--- uspace/srv/devman/loc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/loc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 
 extern void loc_register_tree_function(fun_node_t *, dev_tree_t *);
-extern errno_t loc_unregister_tree_function(fun_node_t *, dev_tree_t *);
+extern int loc_unregister_tree_function(fun_node_t *, dev_tree_t *);
 extern fun_node_t *find_loc_tree_function(dev_tree_t *, service_id_t);
 extern void tree_add_loc_function(dev_tree_t *, fun_node_t *);
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <stdio.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdbool.h>
 #include <fibril_synch.h>
@@ -317,7 +316,7 @@
 	printf("%s: HelenOS Device Manager\n", NAME);
 	
-	errno_t rc = log_init(NAME);
+	int rc = log_init(NAME);
 	if (rc != EOK) {
-		printf("%s: Error initializing logging subsystem: %s\n", NAME, str_error(rc));
+		printf("%s: Error initializing logging subsystem.\n", NAME);
 		return rc;
 	}
@@ -330,29 +329,21 @@
 	rc = async_create_port(INTERFACE_DDF_DRIVER,
 	    devman_connection_driver, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error creating DDF driver port: %s\n", NAME, str_error(rc));
-		return rc;
-	}
+	if (rc != EOK)
+		return rc;
 	
 	rc = async_create_port(INTERFACE_DDF_CLIENT,
 	    devman_connection_client, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error creating DDF client port: %s\n", NAME, str_error(rc));
-		return rc;
-	}
+	if (rc != EOK)
+		return rc;
 	
 	rc = async_create_port(INTERFACE_DEVMAN_DEVICE,
 	    devman_connection_device, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error creating devman device port: %s\n", NAME, str_error(rc));
-		return rc;
-	}
+	if (rc != EOK)
+		return rc;
 	
 	rc = async_create_port(INTERFACE_DEVMAN_PARENT,
 	    devman_connection_parent, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error creating devman parent port: %s\n", NAME, str_error(rc));
-		return rc;
-	}
+	if (rc != EOK)
+		return rc;
 	
 	async_set_fallback_port_handler(devman_forward, NULL);
@@ -366,5 +357,5 @@
 	rc = service_register(SERVICE_DEVMAN);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering as a service: %s", str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering as a service.");
 		return rc;
 	}
Index: uspace/srv/devman/match.c
===================================================================
--- uspace/srv/devman/match.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/devman/match.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -200,18 +200,17 @@
 	int fd;
 	size_t len = 0;
-	vfs_stat_t st;
-	
-	errno_t rc = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ, &fd);
-	if (rc != EOK) {
+	struct stat st;
+	
+	fd = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ);
+	if (fd < 0) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to open `%s' for reading: %s.",
-		    conf_path, str_error(rc));
+		    conf_path, str_error(errno));
 		goto cleanup;
 	}
 	opened = true;
 	
-	rc = vfs_stat(fd, &st);
-	if (rc != EOK) {
+	if (vfs_stat(fd, &st) != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to fstat %d: %s.", fd,
-		    str_error(rc));
+		    str_error(errno));
 		goto cleanup;
 	}
@@ -231,8 +230,8 @@
 	
 	size_t read_bytes;
-	rc = vfs_read(fd, (aoff64_t []) {0}, buf, len, &read_bytes);
+	int rc = vfs_read(fd, (aoff64_t []) {0}, buf, len, &read_bytes);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s': %s.", conf_path,
-		    str_error(rc));
+		    str_error(errno));
 		goto cleanup;
 	}
Index: uspace/srv/fs/cdfs/cdfs.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/cdfs/cdfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,8 +41,6 @@
 #include <ns.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <libfs.h>
-#include <str.h>
 #include "cdfs.h"
 #include "cdfs_ops.h"
@@ -82,8 +80,8 @@
 	}
 	
-	errno_t rc = fs_register(vfs_sess, &cdfs_vfs_info, &cdfs_ops,
+	int rc = fs_register(vfs_sess, &cdfs_vfs_info, &cdfs_ops,
 	    &cdfs_libfs_ops);
 	if (rc != EOK) {
-		printf("%s: Failed to register file system: %s\n", NAME, str_error(rc));
+		printf("%s: Failed to register file system (%d)\n", NAME, rc);
 		return rc;
 	}
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -331,5 +331,5 @@
 };
 
-static errno_t cdfs_node_get(fs_node_t **rfn, service_id_t service_id,
+static int cdfs_node_get(fs_node_t **rfn, service_id_t service_id,
     fs_index_t index)
 {
@@ -351,5 +351,5 @@
 }
 
-static errno_t cdfs_root_get(fs_node_t **rfn, service_id_t service_id)
+static int cdfs_root_get(fs_node_t **rfn, service_id_t service_id)
 {
 	return cdfs_node_get(rfn, service_id, CDFS_SOME_ROOT);
@@ -371,5 +371,5 @@
 }
 
-static errno_t create_node(fs_node_t **rfn, cdfs_t *fs, int lflag,
+static int create_node(fs_node_t **rfn, cdfs_t *fs, int lflag,
     fs_index_t index)
 {
@@ -392,5 +392,5 @@
 	
 	fs_node_t *rootfn;
-	errno_t rc = cdfs_root_get(&rootfn, fs->service_id);
+	int rc = cdfs_root_get(&rootfn, fs->service_id);
 	
 	assert(rc == EOK);
@@ -417,5 +417,5 @@
 }
 
-static errno_t link_node(fs_node_t *pfn, fs_node_t *fn, const char *name)
+static int link_node(fs_node_t *pfn, fs_node_t *fn, const char *name)
 {
 	cdfs_node_t *parent = CDFS_NODE(pfn);
@@ -460,5 +460,5 @@
 static char *cdfs_decode_str(void *data, size_t dsize, cdfs_enc_t enc)
 {
-	errno_t rc;
+	int rc;
 	char *str;
 	uint16_t *buf;
@@ -566,5 +566,5 @@
 }
 
-static errno_t cdfs_readdir(cdfs_t *fs, fs_node_t *fs_node)
+static bool cdfs_readdir(cdfs_t *fs, fs_node_t *fs_node)
 {
 	cdfs_node_t *node = CDFS_NODE(fs_node);
@@ -572,5 +572,5 @@
 	
 	if (node->processed)
-		return EOK;
+		return true;
 	
 	uint32_t blocks = node->size / BLOCK_SIZE;
@@ -580,7 +580,7 @@
 	for (uint32_t i = 0; i < blocks; i++) {
 		block_t *block;
-		errno_t rc = block_get(&block, fs->service_id, node->lba + i, BLOCK_FLAGS_NONE);
+		int rc = block_get(&block, fs->service_id, node->lba + i, BLOCK_FLAGS_NONE);
 		if (rc != EOK)
-			return rc;
+			return false;
 		
 		cdfs_dir_t *dir;
@@ -614,10 +614,8 @@
 			
 			fs_node_t *fn;
-			errno_t rc = create_node(&fn, fs, dentry_type,
+			int rc = create_node(&fn, fs, dentry_type,
 			    (node->lba + i) * BLOCK_SIZE + offset);
-			if (rc != EOK)
-				return rc;
-
-			assert(fn != NULL);
+			if ((rc != EOK) || (fn == NULL))
+				return false;
 			
 			cdfs_node_t *cur = CDFS_NODE(fn);
@@ -628,5 +626,5 @@
 			    dir->name_length, node->fs->enc, dentry_type);
 			if (name == NULL)
-				return EIO;
+				return false;
 			
 			// FIXME: check return value
@@ -643,5 +641,5 @@
 	
 	node->processed = true;
-	return EOK;
+	return true;
 }
 
@@ -652,5 +650,5 @@
 	
 	block_t *block;
-	errno_t rc = block_get(&block, fs->service_id, lba, BLOCK_FLAGS_NONE);
+	int rc = block_get(&block, fs->service_id, lba, BLOCK_FLAGS_NONE);
 	if (rc != EOK)
 		return NULL;
@@ -698,10 +696,10 @@
 }
 
-static errno_t cdfs_match(fs_node_t **fn, fs_node_t *pfn, const char *component)
+static int cdfs_match(fs_node_t **fn, fs_node_t *pfn, const char *component)
 {
 	cdfs_node_t *parent = CDFS_NODE(pfn);
 	
 	if (!parent->processed) {
-		errno_t rc = cdfs_readdir(parent->fs, pfn);
+		int rc = cdfs_readdir(parent->fs, pfn);
 		if (rc != EOK)
 			return rc;
@@ -719,5 +717,5 @@
 }
 
-static errno_t cdfs_node_open(fs_node_t *fn)
+static int cdfs_node_open(fs_node_t *fn)
 {
 	cdfs_node_t *node = CDFS_NODE(fn);
@@ -730,5 +728,5 @@
 }
 
-static errno_t cdfs_node_put(fs_node_t *fn)
+static int cdfs_node_put(fs_node_t *fn)
 {
 	/* Nothing to do */
@@ -736,5 +734,5 @@
 }
 
-static errno_t cdfs_create_node(fs_node_t **fn, service_id_t service_id, int lflag)
+static int cdfs_create_node(fs_node_t **fn, service_id_t service_id, int lflag)
 {
 	/* Read-only */
@@ -742,5 +740,5 @@
 }
 
-static errno_t cdfs_destroy_node(fs_node_t *fn)
+static int cdfs_destroy_node(fs_node_t *fn)
 {
 	/* Read-only */
@@ -748,5 +746,5 @@
 }
 
-static errno_t cdfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *name)
+static int cdfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *name)
 {
 	/* Read-only */
@@ -754,5 +752,5 @@
 }
 
-static errno_t cdfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *name)
+static int cdfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *name)
 {
 	/* Read-only */
@@ -760,5 +758,5 @@
 }
 
-static errno_t cdfs_has_children(bool *has_children, fs_node_t *fn)
+static int cdfs_has_children(bool *has_children, fs_node_t *fn)
 {
 	cdfs_node_t *node = CDFS_NODE(fn);
@@ -806,5 +804,5 @@
 }
 
-static errno_t cdfs_size_block(service_id_t service_id, uint32_t *size)
+static int cdfs_size_block(service_id_t service_id, uint32_t *size)
 {
 	*size = BLOCK_SIZE;
@@ -813,5 +811,5 @@
 }
 
-static errno_t cdfs_total_block_count(service_id_t service_id, uint64_t *count)
+static int cdfs_total_block_count(service_id_t service_id, uint64_t *count)
 {
 	*count = 0;
@@ -820,5 +818,5 @@
 }
 
-static errno_t cdfs_free_block_count(service_id_t service_id, uint64_t *count)
+static int cdfs_free_block_count(service_id_t service_id, uint64_t *count)
 {
 	*count = 0;
@@ -851,5 +849,5 @@
 /** Verify that escape sequence corresonds to one of the allowed encoding
  * escape sequences allowed for Joliet. */
-static errno_t cdfs_verify_joliet_esc_seq(uint8_t *seq)
+static int cdfs_verify_joliet_esc_seq(uint8_t *seq)
 {
 	size_t i, j, k;
@@ -895,5 +893,5 @@
  * @return 		EOK if found, ENOENT if not
  */
-static errno_t cdfs_find_joliet_svd(service_id_t sid, cdfs_lba_t altroot,
+static int cdfs_find_joliet_svd(service_id_t sid, cdfs_lba_t altroot,
     uint32_t *rlba, uint32_t *rsize, char **vol_ident)
 {
@@ -902,5 +900,5 @@
 	for (bi = altroot + 17; ; bi++) {
 		block_t *block;
-		errno_t rc = block_get(&block, sid, bi, BLOCK_FLAGS_NONE);
+		int rc = block_get(&block, sid, bi, BLOCK_FLAGS_NONE);
 		if (rc != EOK)
 			break;
@@ -963,12 +961,12 @@
 
 /** Read the volume descriptors. */
-static errno_t iso_read_vol_desc(service_id_t sid, cdfs_lba_t altroot,
+static bool iso_read_vol_desc(service_id_t sid, cdfs_lba_t altroot,
     uint32_t *rlba, uint32_t *rsize, cdfs_enc_t *enc, char **vol_ident)
 {
 	/* First 16 blocks of isofs are empty */
 	block_t *block;
-	errno_t rc = block_get(&block, sid, altroot + 16, BLOCK_FLAGS_NONE);
+	int rc = block_get(&block, sid, altroot + 16, BLOCK_FLAGS_NONE);
 	if (rc != EOK)
-		return rc;
+		return false;
 	
 	cdfs_vol_desc_t *vol_desc = (cdfs_vol_desc_t *) block->data;
@@ -982,5 +980,5 @@
 	    (vol_desc->version != 1)) {
 		block_put(block);
-		return ENOTSUP;
+		return false;
 	}
 	
@@ -1002,5 +1000,5 @@
 		 */
 		block_put(block);
-		return ENOTSUP;
+		return false;
 	}
 	
@@ -1008,5 +1006,5 @@
 	if (block_size != BLOCK_SIZE) {
 		block_put(block);
-		return ENOTSUP;
+		return false;
 	}
 	
@@ -1033,16 +1031,15 @@
 	
 	block_put(block);
-	return EOK;
-}
-
-static errno_t iso_readfs(cdfs_t *fs, fs_node_t *rfn,
+	return true;
+}
+
+static bool iso_readfs(cdfs_t *fs, fs_node_t *rfn,
     cdfs_lba_t altroot)
 {
 	cdfs_node_t *node = CDFS_NODE(rfn);
 	
-	errno_t rc = iso_read_vol_desc(fs->service_id, altroot, &node->lba,
-	    &node->size, &fs->enc, &fs->vol_ident);
-	if (rc != EOK)
-		return rc;
+	if (!iso_read_vol_desc(fs->service_id, altroot, &node->lba,
+	    &node->size, &fs->enc, &fs->vol_ident))
+		return false;
 	
 	return cdfs_readdir(fs, rfn);
@@ -1064,5 +1061,5 @@
 	
 	/* Create root node */
-	errno_t rc = create_node(&rfn, fs, L_DIRECTORY, cdfs_index++);
+	int rc = create_node(&rfn, fs, L_DIRECTORY, cdfs_index++);
 	
 	if ((rc != EOK) || (!rfn))
@@ -1075,5 +1072,5 @@
 	
 	/* Check if there is cdfs in given session */
-	if (iso_readfs(fs, rfn, altroot) != EOK)
+	if (!iso_readfs(fs, rfn, altroot))
 		goto error;
 	
@@ -1086,10 +1083,10 @@
 }
 
-static errno_t cdfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static int cdfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
 {
 	char *vol_ident;
 
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	int rc = block_init(service_id, BLOCK_SIZE);
 	if (rc != EOK)
 		return rc;
@@ -1128,10 +1125,9 @@
 	uint32_t rsize;
 	cdfs_enc_t enc;
-	rc = iso_read_vol_desc(service_id, altroot, &rlba, &rsize, &enc,
-	    &vol_ident);
-	if (rc != EOK) {
+	if (!iso_read_vol_desc(service_id, altroot, &rlba, &rsize, &enc,
+	    &vol_ident)) {
 		block_cache_fini(service_id);
 		block_fini(service_id);
-		return rc;
+		return EIO;
 	}
 	
@@ -1144,9 +1140,9 @@
 }
 
-static errno_t cdfs_mounted(service_id_t service_id, const char *opts,
+static int cdfs_mounted(service_id_t service_id, const char *opts,
     fs_index_t *index, aoff64_t *size)
 {
 	/* Initialize the block layer */
-	errno_t rc = block_init(service_id, BLOCK_SIZE);
+	int rc = block_init(service_id, BLOCK_SIZE);
 	if (rc != EOK)
 		return rc;
@@ -1238,5 +1234,5 @@
 }
 
-static errno_t cdfs_unmounted(service_id_t service_id)
+static int cdfs_unmounted(service_id_t service_id)
 {
 	cdfs_t *fs;
@@ -1250,5 +1246,5 @@
 }
 
-static errno_t cdfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
+static int cdfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *rbytes)
 {
@@ -1266,5 +1262,5 @@
 	
 	if (!node->processed) {
-		errno_t rc = cdfs_readdir(node->fs, FS_NODE(node));
+		int rc = cdfs_readdir(node->fs, FS_NODE(node));
 		if (rc != EOK)
 			return rc;
@@ -1290,5 +1286,5 @@
 			
 			block_t *block;
-			errno_t rc = block_get(&block, service_id, node->lba + lba,
+			int rc = block_get(&block, service_id, node->lba + lba,
 			    BLOCK_FLAGS_NONE);
 			if (rc != EOK) {
@@ -1321,5 +1317,5 @@
 }
 
-static errno_t cdfs_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
+static int cdfs_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *wbytes, aoff64_t *nsize)
 {
@@ -1332,5 +1328,5 @@
 }
 
-static errno_t cdfs_truncate(service_id_t service_id, fs_index_t index,
+static int cdfs_truncate(service_id_t service_id, fs_index_t index,
     aoff64_t size)
 {
@@ -1373,5 +1369,5 @@
 }
 
-static errno_t cdfs_close(service_id_t service_id, fs_index_t index)
+static int cdfs_close(service_id_t service_id, fs_index_t index)
 {
 	/* Root node is always in memory */
@@ -1399,5 +1395,5 @@
 }
 
-static errno_t cdfs_destroy(service_id_t service_id, fs_index_t index)
+static int cdfs_destroy(service_id_t service_id, fs_index_t index)
 {
 	/*
@@ -1409,5 +1405,5 @@
 }
 
-static errno_t cdfs_sync(service_id_t service_id, fs_index_t index)
+static int cdfs_sync(service_id_t service_id, fs_index_t index)
 {
 	/*
Index: uspace/srv/fs/exfat/exfat.c
===================================================================
--- uspace/srv/fs/exfat/exfat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/exfat/exfat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,7 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
 #include <libfs.h>
-#include <str.h>
 #include "../../vfs/vfs.h"
 
@@ -72,5 +70,5 @@
 	}
 
-	errno_t rc = exfat_idx_init();
+	int rc = exfat_idx_init();
 	if (rc != EOK)
 		goto err;
@@ -97,5 +95,5 @@
 
 err:
-	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
+	printf(NAME ": Failed to register file system (%d)\n", rc);
 	return rc;
 }
Index: uspace/srv/fs/exfat/exfat.h
===================================================================
--- uspace/srv/fs/exfat/exfat.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/exfat/exfat.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -169,5 +169,5 @@
 extern libfs_ops_t exfat_libfs_ops;
 
-extern errno_t exfat_idx_get_new(exfat_idx_t **, service_id_t);
+extern int exfat_idx_get_new(exfat_idx_t **, service_id_t);
 extern exfat_idx_t *exfat_idx_get_by_pos(service_id_t, exfat_cluster_t, unsigned);
 extern exfat_idx_t *exfat_idx_get_by_index(service_id_t, fs_index_t);
@@ -176,13 +176,13 @@
 extern void exfat_idx_hashout(exfat_idx_t *);
 
-extern errno_t exfat_idx_init(void);
+extern int exfat_idx_init(void);
 extern void exfat_idx_fini(void);
-extern errno_t exfat_idx_init_by_service_id(service_id_t);
+extern int exfat_idx_init_by_service_id(service_id_t);
 extern void exfat_idx_fini_by_service_id(service_id_t);
 
-extern errno_t exfat_node_expand(service_id_t, exfat_node_t *, exfat_cluster_t);
-extern errno_t exfat_node_put(fs_node_t *);
-extern errno_t exfat_bitmap_get(fs_node_t **, service_id_t);
-extern errno_t exfat_uctable_get(fs_node_t **, service_id_t);
+extern int exfat_node_expand(service_id_t, exfat_node_t *, exfat_cluster_t);
+extern int exfat_node_put(fs_node_t *);
+extern int exfat_bitmap_get(fs_node_t **, service_id_t);
+extern int exfat_uctable_get(fs_node_t **, service_id_t);
 
 
